package com.ruoyi.system.service.impl;


import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.utils.SecurityUtils;

import com.ruoyi.system.mapper.PowerDisplayMapper;
import com.ruoyi.system.model.newrule.NewRuleRequestModel;
import com.ruoyi.system.model.power.PowerSourceModel;
import com.ruoyi.system.model.power.dao.PowerClassificationQueryDao;
import com.ruoyi.system.model.power.dao.PowerControlDao;
import com.ruoyi.system.model.power.dto.PowerDisplayDto;
import com.ruoyi.system.model.salary.ConfigModel;
import com.ruoyi.system.service.PowerDisplayService;
import com.ruoyi.system.service.impl.saveOnTheLargeScreenPower.*;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;
import org.springframework.util.ReflectionUtils;
import redis.clients.jedis.Jedis;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.*;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.stream.Collectors;

/**
 * 2024/7/30
 */
@Service
public class PowerDisplayServiceImpl implements PowerDisplayService {
    private final PowerDisplayMapper powerDisplayMapper;

    PowerDisplayServiceImpl(PowerDisplayMapper powerDisplayMapper) {
        this.powerDisplayMapper = powerDisplayMapper;
    }

    @Override
    public void peek(List<NewRuleRequestModel> electricityIntoTheParameterDtoDtoList) {
        Jedis redis = new Jedis("192.168.111.226", 6379);
        SysUser user = SecurityUtils.getLoginUser().getUser();
        if (redis.exists("电力导入" + user) && redis.get("电力导入" + user).equals("电力导入大屏")) {
            redis.close();
            return;
        }
        redis.set("电力导入" + user, "电力导入大屏");
        redis.expire("电力导入" + user, 5);
        redis.close();
        electricityIntoTheParameterDtoDtoList.forEach(v -> v.setRow(v.getRow().split("-")[1]));
        electricityIntoTheParameterDtoDtoList.forEach(v -> v.setRow(v.getRow().replace(" ", "")));
        String mindId = electricityIntoTheParameterDtoDtoList.get(0).getMineid().replaceAll(" ", "");
        List<PowerControlDao> controlList = powerDisplayMapper.selControl(mindId);
        List<PowerDisplayDto> powerDisplayDtoList = new ArrayList<>();
        Class<PowerDisplayDto> powerDisplayDtoClass = PowerDisplayDto.class;
        AtomicBoolean b = new AtomicBoolean(false);
        PowerDisplayDto xs011701 = null;
        electricityIntoTheParameterDtoDtoList.forEach(v -> {
            if (controlList.parallelStream().noneMatch(a -> a.getColumn().equals(v.getColoumn()))) return;
            PowerDisplayDto displayDto;
            if ("011704".equals(mindId) && v.getRow().equals("电价（含税）")) return;
            if ("010105".equals(mindId) && (v.getRow().contains("（尖）") || v.getRow().contains("（峰）") || v.getRow().contains("（平）") || v.getRow().contains("（谷）") || v.getColoumn().equals("单价")))
                return;
            if ("011701".equals(mindId) && (v.getColoumn().equals("照明电价") || v.getColoumn().equals("动力电价") || v.getRow().contains("多经公司")))
                return;
            if (!powerDisplayDtoList.isEmpty()) {
                powerDisplayDtoList.removeAll(Collections.singleton(null));
                b.set(powerDisplayDtoList.stream().anyMatch(a -> a.getClassificationName().equals(v.getRow())));
            }
            if (b.get()) {
                displayDto = powerDisplayDtoList.stream().filter(a -> a.getClassificationName().equals(v.getRow())).findFirst().get();
            } else {
                displayDto = new PowerDisplayDto();
                displayDto.setClassificationName(v.getRow());
                powerDisplayDtoList.add(displayDto);
            }
            if (mindId.equals("011701") && v.getRow().equals("线损") && v.getColoumn().equals("本月")) {
                xs011701.setPowerTotal(v.getValue());
                return;
            }
            Optional<PowerControlDao> first = controlList.parallelStream().filter(a -> a.getColumn().equals(v.getColoumn())).findFirst();
            if (first.isPresent() && first.get().getColumn() != null && first.get().getField() != null) {
                PowerControlDao powerControlDao = first.get();
                try {
                    Method method = powerDisplayDtoClass.getMethod("set" + powerControlDao.getField(), String.class);
                    method.invoke(displayDto, v.getValue());
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            b.set(false);
        });
        List<PowerClassificationQueryDao> dao = powerDisplayMapper.selectClassificationToMid(mindId);
        SaveOnTheLargeScreenImpl saveOnTheLargeScreen = null;
        List<String> linXi = Collections.singletonList("011704");
        List<String> lvJiaTuo = Collections.singletonList("011702");
        List<String> danHou = Collections.singletonList("011204");
        List<String> dongHuanTuo = Collections.singletonList("010102");
        List<String> qianJiaYing = Collections.singletonList("010105");
        List<String> fanGeZhuang = Collections.singletonList("011701");
        List<String> tangShanKuang = Collections.singletonList("010101");
        List<String> field = powerDisplayMapper.selField(mindId);
        List<PowerDisplayDto> collect1 = powerDisplayDtoList.parallelStream().filter(v -> !field.contains(v.getClassificationName())).collect(Collectors.toList());
        if (linXi.contains(mindId)) {
            List<NewRuleRequestModel> collect = electricityIntoTheParameterDtoDtoList.parallelStream().filter(v -> v.getRow().equals("电价（含税）")).collect(Collectors.toList());
            collect.forEach(v -> v.setColoumn(v.getColoumn() + "-费"));
            if (!collect.isEmpty()) {
                collect.parallelStream().forEach(v -> {
                    Optional<PowerControlDao> first = controlList.parallelStream().filter(a -> a.getColumn().equals(v.getColoumn())).findFirst();
                    try {
                        if (first.isPresent()) {
                            PowerControlDao powerControlDao = first.get();
                            Method method = powerDisplayDtoClass.getMethod("set" + powerControlDao.getField(), String.class);
                            for (PowerDisplayDto displayDto : collect1) {
                                method.invoke(displayDto, v.getValue());
                            }
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                });
            }
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new LinXi());
        } else if (lvJiaTuo.contains(mindId)) {
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new LvJiaTuo());
        } else if (danHou.contains(mindId)) {
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new DanHou());
        } else if (dongHuanTuo.contains(mindId)) {
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new DongHuanTuo());
        } else if (qianJiaYing.contains(mindId)) {
            List<NewRuleRequestModel> collect = electricityIntoTheParameterDtoDtoList
                    .parallelStream()
                    .filter(v -> v.getRow().contains("（尖）") || v.getRow().contains("（峰）") || v.getRow().contains("（平）") || v.getRow().contains("（谷）"))
                    .collect(Collectors.toList());
            if (!collect.isEmpty()) {
                PowerDisplayDto displayDto;
                for (NewRuleRequestModel dto : collect) {
                    String[] split = dto.getRow().split("-");
                    Optional<PowerDisplayDto> first = collect1.parallelStream().filter(v -> v.getClassificationName().equals(split[0])).findFirst();
                    if (first.isPresent()) displayDto = first.get();
                    else {
                        displayDto = new PowerDisplayDto();
                        displayDto.setClassificationName(split[0]);
                    }
                    try {
                        Method method = powerDisplayDtoClass.getMethod("set" + dto.getColoumn(), String.class);
                        method.invoke(displayDto, dto.getValue());
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new QianJiaYing());
        } else if (fanGeZhuang.contains(mindId)) {
            List<NewRuleRequestModel> collect = electricityIntoTheParameterDtoDtoList.parallelStream().filter(v -> v.getRow().contains("多经公司")).collect(Collectors.toList());
            if (!collect.isEmpty()) {
                PowerDisplayDto dto = new PowerDisplayDto();
                String[] split = collect.get(0).getRow().split("-");
                dto.setClassificationName(split[0]);
                for (NewRuleRequestModel model : collect) {
                    String[] strings = model.getRow().split("-");
                    switch (strings[1]) {
                        case "峰":
                            dto.setPowerPeak(model.getValue());
                            break;
                        case "平":
                            dto.setPowerFlat(model.getValue());
                            break;
                        case "谷":
                            dto.setPowerValley(model.getValue());
                            break;
                        case "尖":
                            dto.setPowerTip(model.getValue());
                            break;
                    }
                }
            }
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new FanGeZhuang());
        } else if (tangShanKuang.contains(mindId)) {
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new TangShanKuang());
        }
        if (saveOnTheLargeScreen != null) {
            // 添加费用来源
            List<PowerDisplayDto> list = saveOnTheLargeScreen.save(mindId, collect1, dao);
            // 单另处理电费
            if (mindId.equals("010105")) method(list, electricityIntoTheParameterDtoDtoList);
            if (mindId.equals("011701")) methodFgz(list, electricityIntoTheParameterDtoDtoList);
            list.forEach(v -> {
                if (v.getLevelOneClassification() == null || v.getLevelOneClassification().isEmpty())
                    v.setLevelOneClassification("其他");
                v.setMindId(mindId);
                v.setDateColumn(electricityIntoTheParameterDtoDtoList.get(0).getWageMonth());
            });
            list = list.stream().filter(v -> !v.getClassificationName().contains("合计")).collect(Collectors.toList());
            powerDisplayMapper.insert(list);
//            List<PowerDisplayDto> selPower = powerDisplayMapper.selOfMid(mindId, electricityIntoTheParameterDtoDtoList.get(0).getWageMonth());
//            selPower.removeAll(Collections.singleton(null));
//            // 已有不需新增
//            List<PowerDisplayDto> collect = list.stream()
//                    .filter(v -> selPower.stream().anyMatch(a -> v.getClassificationName().equals(a.getClassificationName()))
//                            && selPower.stream().anyMatch(a -> v.getLevelOneClassification().equals(a.getLevelOneClassification())))
//                    .collect(Collectors.toList());
//            // 需新增
//            List<PowerDisplayDto> dtoList = list.stream()
//                    .filter(v -> !selPower.stream().anyMatch(a -> v.getClassificationName().equals(a.getClassificationName()))
//                            && !selPower.stream().anyMatch(a -> v.getLevelOneClassification().equals(a.getLevelOneClassification())))
//                    .collect(Collectors.toList());
//            if (dtoList.size() != 0) powerDisplayMapper.insert(dtoList);
//            if (collect.size() != 0) powerDisplayMapper.update(collect);
        }
    }


    /**
     * 011701电价的处理方法
     *
     * @param list
     * @param electricityIntoTheParameterDtoDtoList
     */
    private void methodFgz(List<PowerDisplayDto> list, List<NewRuleRequestModel> electricityIntoTheParameterDtoDtoList) {
        String electricityPricesForLighting = electricityIntoTheParameterDtoDtoList.parallelStream().filter(v -> v.getColoumn().equals("照明电价")).findFirst().get().getValue();
        String powerTariff = electricityIntoTheParameterDtoDtoList.parallelStream().filter(v -> v.getColoumn().equals("动力电价")).findFirst().get().getValue();
        list.parallelStream().forEach(v -> {
            if ((v.getElectricityPriceFlat() != null && !v.getElectricityPriceFlat().isEmpty()) ||
                    (v.getElectricityPricePeak() != null && !v.getElectricityPricePeak().isEmpty()) ||
                    (v.getElectricityPriceTip() != null && !v.getElectricityPriceTip().isEmpty()) ||
                    (v.getElectricityPriceValley() != null && !v.getElectricityPriceValley().isEmpty())) return;
            if (v.getLevelThreeClassification().equals("动力用电")) {
                v.setElectricityPriceValley(powerTariff);
                v.setElectricityPriceFlat(powerTariff);
                v.setElectricityPricePeak(powerTariff);
                v.setElectricityPriceTip(powerTariff);
            }
            if (v.getLevelThreeClassification().equals("照明用电")) {
                v.setElectricityPriceValley(electricityPricesForLighting);
                v.setElectricityPriceFlat(electricityPricesForLighting);
                v.setElectricityPricePeak(electricityPricesForLighting);
                v.setElectricityPriceTip(electricityPricesForLighting);
            }
        });
    }

    /**
     * 010105电价的处理方法
     *
     * @param list
     * @param electricityIntoTheParameterDtoDtoList
     */
    private void method(List<PowerDisplayDto> list, List<NewRuleRequestModel> electricityIntoTheParameterDtoDtoList) {
        for (PowerDisplayDto dto : list) {
            if ((dto.getElectricityPriceFlat() == null || dto.getElectricityPriceFlat().isEmpty()) && (dto.getElectricityPricePeak() == null || dto.getElectricityPricePeak().isEmpty()) &&
                    (dto.getElectricityPriceTip() == null || dto.getElectricityPriceTip().isEmpty()) && (dto.getElectricityPriceValley() == null || dto.getElectricityPriceValley().isEmpty())) {
                Optional<NewRuleRequestModel> first = electricityIntoTheParameterDtoDtoList.parallelStream().filter(v -> (v.getRow().equals(dto.getLevelOneClassification()) || v.getRow().equals(dto.getLevelTwoClassification())) && v.getColoumn().equals("单价")).findFirst();
                if (first.isPresent()) {
                    NewRuleRequestModel model = first.get();
                    dto.setElectricityPriceValley(model.getValue());
                    dto.setElectricityPriceFlat(model.getValue());
                    dto.setElectricityPricePeak(model.getValue());
                    dto.setElectricityPriceTip(model.getValue());
                }
            }
        }
    }

    @Override
    public AjaxResult save(List<NewRuleRequestModel> powerDisplayDtoList) {
        if (!CollectionUtils.isEmpty(powerDisplayDtoList)) {
            String mineid = powerDisplayDtoList.get(0).getMineid();
            if (StringUtils.equals("011702", mineid)) {
                saveLJTPowerData(powerDisplayDtoList);
            }
            if (StringUtils.equals("011701", mineid)) {
                saveFGZPowerData(powerDisplayDtoList);
            }
        } else {
            return AjaxResult.error();
        }
        return AjaxResult.success();
    }

    /**
     * 范各庄
     *
     * @param powerDisplayDtoList
     */
    private void saveFGZPowerData(List<NewRuleRequestModel> powerDisplayDtoList) {

        ReplaceBlank(powerDisplayDtoList);
        List<PowerDisplayDto> displayDtoList = getPowerDisplayDtoList(powerDisplayDtoList);

    }

    /**
     * 吕家坨
     *
     * @param powerDisplayDtoList
     */
    private void saveLJTPowerData(List<NewRuleRequestModel> powerDisplayDtoList) {
        ReplaceBlank(powerDisplayDtoList);
        List<PowerDisplayDto> displayDtoList = getPowerDisplayDtoList(powerDisplayDtoList);
        disposeParamter(displayDtoList);
        Map<String, List<PowerDisplayDto>> map = displayDtoList.stream().collect(Collectors.groupingBy(PowerDisplayDto::getClassificationName));
        List<PowerDisplayDto> finalList = new ArrayList<>();
        map.forEach((k, v) -> {
            PowerDisplayDto pd = megreData(v);
            finalList.add(pd);
        });
        List<PowerDisplayDto> collect = finalList.stream().filter(v -> !StringUtils.contains(v.getClassificationName(), "合计")).collect(Collectors.toList());
        List<PowerSourceModel> powerSourceModelList = powerDisplayMapper.selectSource("011702");
        collect = collect.stream().filter(v -> powerSourceModelList.stream().noneMatch(powerSourceModel -> StringUtils.equals(v.getClassificationName(), powerSourceModel.getLevelOneClassification()))).collect(Collectors.toList());
        collect.forEach(v->{
            for (PowerSourceModel powerSourceModel : powerSourceModelList) {
                if (StringUtils.equals(v.getClassificationName(),powerSourceModel.getClassificationName())){
                    v.setLevelOneClassification(powerSourceModel.getLevelOneClassification());
                }
            }
        });
        powerDisplayMapper.insert(collect);
    }

    private PowerDisplayDto megreData(List<PowerDisplayDto> powerDisplayDtoList) {
        return powerDisplayDtoList.stream().collect(Collectors.collectingAndThen(Collectors.toMap(data -> data.getMindId() + data.getClassificationName() + data.getDateColumn(), data -> data, (existingData, newData) -> {
            existingData.setPowerTotal(StringUtils.isEmpty(existingData.getPowerTotal()) ? newData.getPowerTotal() : existingData.getPowerTotal());
            existingData.setPowerTip(StringUtils.isEmpty(existingData.getPowerTip()) ? newData.getPowerTip() : existingData.getPowerTip());
            existingData.setPowerPeak(StringUtils.isEmpty(existingData.getPowerPeak()) ? newData.getPowerPeak() : existingData.getPowerPeak());
            existingData.setPowerFlat(StringUtils.isEmpty(existingData.getPowerFlat()) ? newData.getPowerFlat() : existingData.getPowerFlat());
            existingData.setPowerValley(StringUtils.isEmpty(existingData.getPowerValley()) ? newData.getPowerValley() : existingData.getPowerValley());
            existingData.setElectricityTotal(StringUtils.isEmpty(existingData.getElectricityTotal()) ? newData.getElectricityTotal() : existingData.getElectricityTotal());
            existingData.setElectricityTip(StringUtils.isEmpty(existingData.getElectricityTip()) ? newData.getElectricityTip() : existingData.getElectricityTip());
            existingData.setElectricityPeak(StringUtils.isEmpty(existingData.getElectricityPeak()) ? newData.getElectricityPeak() : existingData.getElectricityPeak());
            existingData.setElectricityFlat(StringUtils.isEmpty(existingData.getElectricityFlat()) ? newData.getElectricityFlat() : existingData.getElectricityFlat());
            existingData.setElectricityValley(StringUtils.isEmpty(existingData.getElectricityValley()) ? newData.getElectricityValley() : existingData.getElectricityValley());
            existingData.setElectricityPriceTip(StringUtils.isEmpty(existingData.getElectricityPriceTip()) ? newData.getElectricityPriceTip() : existingData.getElectricityPriceTip());
            existingData.setElectricityPricePeak(StringUtils.isEmpty(existingData.getElectricityPricePeak()) ? newData.getElectricityPricePeak() : existingData.getElectricityPricePeak());
            existingData.setElectricityPriceFlat(StringUtils.isEmpty(existingData.getElectricityPriceFlat()) ? newData.getElectricityPriceFlat() : existingData.getElectricityPriceFlat());
            existingData.setElectricityPriceValley(StringUtils.isEmpty(existingData.getElectricityPriceValley()) ? newData.getElectricityPriceValley() : existingData.getElectricityPriceValley());
            existingData.setLevelOneClassification(StringUtils.isEmpty(existingData.getLevelOneClassification()) ? newData.getLevelOneClassification() : existingData.getLevelOneClassification());
            existingData.setLevelTwoClassification(StringUtils.isEmpty(existingData.getLevelTwoClassification()) ? newData.getLevelTwoClassification() : existingData.getLevelTwoClassification());
            existingData.setLevelThreeClassification(StringUtils.isEmpty(existingData.getLevelThreeClassification()) ? newData.getLevelThreeClassification() : existingData.getLevelThreeClassification());
            existingData.setBasicElectricityTariff(StringUtils.isEmpty(existingData.getBasicElectricityTariff()) ? newData.getBasicElectricityTariff() : existingData.getBasicElectricityTariff());
            return existingData;
        }), map -> map.values().iterator().next()));
    }


    private List<PowerDisplayDto> getPowerDisplayDtoList(List<NewRuleRequestModel> powerDisplayDtoList) {
        List<PowerDisplayDto> displayDtoList = new ArrayList<>();
        List<ConfigModel> configModelList = powerDisplayMapper.seletPowerConfig();
        Map<String, List<NewRuleRequestModel>> map = powerDisplayDtoList.stream().collect(Collectors.groupingBy(NewRuleRequestModel::getRow));
        map.forEach((k, v) -> {
            PowerDisplayDto powerDisplayDto = new PowerDisplayDto();
            for (NewRuleRequestModel newRuleRequestModel : v) {
                for (ConfigModel configModel : configModelList) {
                    if (StringUtils.contains(newRuleRequestModel.getColoumn(), configModel.getColName())) {
                        Field field;
                        try {
                            field = PowerDisplayDto.class.getDeclaredField(configModel.getKeyName());
                            ReflectionUtils.makeAccessible(field);
                            ReflectionUtils.setField(field, powerDisplayDto, newRuleRequestModel.getValue());
                        } catch (NoSuchFieldException e) {
                            throw new RuntimeException(e);
                        }
                    }
                }
                powerDisplayDto.setClassificationName(k);
                powerDisplayDto.setDateColumn(newRuleRequestModel.getWageMonth());
                powerDisplayDto.setMindId(newRuleRequestModel.getMineid());
            }
            displayDtoList.add(powerDisplayDto);
        });
        return displayDtoList;

    }


    private void ReplaceBlank(List<NewRuleRequestModel> powerDisplayDtoList) {
        powerDisplayDtoList.forEach(v -> {
            v.setRow(v.getRow().replaceAll(StringUtils.SPACE, StringUtils.EMPTY));
            v.setValue(v.getValue().replaceAll(StringUtils.SPACE, StringUtils.EMPTY));
            v.setColoumn(v.getColoumn().replaceAll(StringUtils.SPACE, StringUtils.EMPTY));
        });
    }

    private void disposeParamter(List<PowerDisplayDto> displayDtoList) {
        for (PowerDisplayDto powerDisplayDto : displayDtoList) {
            if (org.apache.commons.lang3.StringUtils.contains(powerDisplayDto.getClassificationName(), "其中")) {
                powerDisplayDto.setClassificationName(powerDisplayDto.getClassificationName().replaceAll("其中：", StringUtils.EMPTY));
            }
            powerDisplayDto.setClassificationName(powerDisplayDto.getClassificationName().replaceAll("[^\\u4e00-\\u9fa5]", StringUtils.EMPTY));
        }
    }

}
